from header_common import *

###################################################
# header_troops.py
# This file contains declarations for troops
# DO NOT EDIT THIS FILE!
###################################################

#Troop flags
tf_male           = 0
tf_female         = 1
tf_skeleton         = 2
tf_cannon_walker    = 3
tf_death_knight    = 4
tf_remnant    = 5
tf_flesh_golem    = 6
troop_type_mask   = 0x0000000f
tf_hero              = 0x00000010
tf_inactive          = 0x00000020
tf_unkillable        = 0x00000040
tf_always_fall_dead = 0x00000080
tf_no_capture_alive  = 0x00000100
tf_mounted           = 0x00000400 #Troop's movement speed on map is determined by riding skill.
tf_is_merchant       = 0x00001000 #When set, troop does not equip stuff he owns
tf_randomize_face    = 0x00008000 #randomize face at the beginning of the game.

tf_guarantee_boots            = 0x00100000
tf_guarantee_armor            = 0x00200000
tf_guarantee_helmet           = 0x00400000
tf_guarantee_gloves           = 0x00800000
tf_guarantee_horse            = 0x01000000
tf_guarantee_shield           = 0x02000000
tf_guarantee_ranged           = 0x04000000
tf_unmoveable_in_party_window = 0x10000000

# Character attributes...
ca_strength     = 0
ca_agility      = 1
ca_intelligence = 2
ca_charisma     = 3

wpt_one_handed_weapon = 0
wpt_two_handed_weapon = 1
wpt_polearm           = 2
wpt_archery           = 3
wpt_crossbow          = 4
wpt_throwing          = 5
wpt_firearm           = 6


#personality modifiers:
# courage 8 means neutral
courage_4  = 0x0004
courage_5  = 0x0005
courage_6  = 0x0006
courage_7  = 0x0007
courage_8  = 0x0008
courage_9  = 0x0009
courage_10 = 0x000A
courage_11 = 0x000B
courage_12 = 0x000C
courage_13 = 0x000D
courage_14 = 0x000E
courage_15 = 0x000F

aggresiveness_1  = 0x0010
aggresiveness_2  = 0x0020
aggresiveness_3  = 0x0030
aggresiveness_4  = 0x0040
aggresiveness_5  = 0x0050
aggresiveness_6  = 0x0060
aggresiveness_7  = 0x0070
aggresiveness_8  = 0x0080
aggresiveness_9  = 0x0090
aggresiveness_10 = 0x00A0
aggresiveness_11 = 0x00B0
aggresiveness_12 = 0x00C0
aggresiveness_13 = 0x00D0
aggresiveness_14 = 0x00E0
aggresiveness_15 = 0x00F0

is_bandit        = 0x0100
#-----------------------------------
#these also in sentences.py
tsf_site_id_mask = 0x0000ffff
tsf_entry_mask   = 0x00ff0000
tsf_entry_bits   = 16

def entry(n):
  return (((n) << tsf_entry_bits) & tsf_entry_mask)
#-------------------------------------

str_1            = bignum | 0x00000001
str_2            = bignum | 0x00000002
str_3            = bignum | 0x00000003
str_4            = bignum | 0x00000004
str_5            = bignum | 0x00000005
str_6            = bignum | 0x00000006
str_7            = bignum | 0x00000007
str_8            = bignum | 0x00000008
str_9            = bignum | 0x00000009
str_10           = bignum | 0x0000000a
str_11           = bignum | 0x0000000b
str_12           = bignum | 0x0000000c
str_13           = bignum | 0x0000000d
str_14           = bignum | 0x0000000e
str_15           = bignum | 0x0000000f
str_16           = bignum | 0x00000010
str_17           = bignum | 0x00000011
str_18           = bignum | 0x00000012
str_19           = bignum | 0x00000013
str_20           = bignum | 0x00000014
str_21           = bignum | 0x00000015
str_22           = bignum | 0x00000016
str_23           = bignum | 0x00000017
str_24           = bignum | 0x00000018
str_25           = bignum | 0x00000019
str_26           = bignum | 0x0000001a
str_27           = bignum | 0x0000001b
str_28           = bignum | 0x0000001c
str_29           = bignum | 0x0000001d
str_30           = bignum | 0x0000001e
str_31           = bignum | 0x0000001f
str_32           = bignum | 0x00000020
str_33           = bignum | 0x00000021
str_34           = bignum | 0x00000022
str_35           = bignum | 0x00000023
str_36           = bignum | 0x00000024
str_37           = bignum | 0x00000025
str_38           = bignum | 0x00000026
str_39           = bignum | 0x00000027
str_40           = bignum | 0x00000028
str_41           = bignum | 0x00000029
str_42           = bignum | 0x0000002a
str_43           = bignum | 0x0000002b
str_44           = bignum | 0x0000002c
str_45           = bignum | 0x0000002d
str_46           = bignum | 0x0000002e
str_47           = bignum | 0x0000002f
str_48           = bignum | 0x00000030
str_49           = bignum | 0x00000031
str_50           = bignum | 0x00000032
str_51           = bignum | 0x00000033
str_52           = bignum | 0x00000034
str_53           = bignum | 0x00000035
str_54           = bignum | 0x00000036
str_55           = bignum | 0x00000037
str_56           = bignum | 0x00000038
str_57           = bignum | 0x00000039
str_58           = bignum | 0x0000003a
str_59           = bignum | 0x0000003b
str_60           = bignum | 0x0000003c
str_61           = bignum | 0x0000003d
str_62           = bignum | 0x0000003e
str_63           = bignum | 0x0000003f
str_64           = bignum | 0x00000040
str_65           = bignum | 0x00000041
str_66           = bignum | 0x00000042
str_67           = bignum | 0x00000043
str_68           = bignum | 0x00000044
str_69           = bignum | 0x00000045
str_70           = bignum | 0x00000046
str_71           = bignum | 0x00000047
str_72           = bignum | 0x00000048
str_73           = bignum | 0x00000049
str_74           = bignum | 0x0000004a
str_75           = bignum | 0x0000004b
str_76           = bignum | 0x0000004c
str_77           = bignum | 0x0000004d
str_78           = bignum | 0x0000004e
str_79           = bignum | 0x0000004f
str_80           = bignum | 0x00000050
str_81           = bignum | 0x00000051
str_82           = bignum | 0x00000052
str_83           = bignum | 0x00000053
str_84           = bignum | 0x00000054
str_85           = bignum | 0x00000055
str_86           = bignum | 0x00000056
str_87           = bignum | 0x00000057
str_88           = bignum | 0x00000058
str_89           = bignum | 0x00000059
str_90           = bignum | 0x0000005a
str_91           = bignum | 0x0000005b
str_92           = bignum | 0x0000005c
str_93           = bignum | 0x0000005d
str_94           = bignum | 0x0000005e
str_95           = bignum | 0x0000005f
str_96           = bignum | 0x00000060
str_97           = bignum | 0x00000061
str_98           = bignum | 0x00000062
str_99           = bignum | 0x00000063
str_100          = bignum | 0x00000064
str_101          = bignum | 0x00000065
str_102          = bignum | 0x00000066
str_103          = bignum | 0x00000067
str_104          = bignum | 0x00000068
str_105          = bignum | 0x00000069
str_106          = bignum | 0x0000006a
str_107          = bignum | 0x0000006b
str_108          = bignum | 0x0000006c
str_109          = bignum | 0x0000006d
str_110          = bignum | 0x0000006e
str_111          = bignum | 0x0000006f
str_112          = bignum | 0x00000070
str_113          = bignum | 0x00000071
str_114          = bignum | 0x00000072
str_115          = bignum | 0x00000073
str_116          = bignum | 0x00000074
str_117          = bignum | 0x00000075
str_118          = bignum | 0x00000076
str_119          = bignum | 0x00000077
str_120          = bignum | 0x00000078
str_121          = bignum | 0x00000079
str_122          = bignum | 0x0000007a
str_123          = bignum | 0x0000007b
str_124          = bignum | 0x0000007c
str_125          = bignum | 0x0000007d
str_126          = bignum | 0x0000007e
str_127          = bignum | 0x0000007f
str_128          = bignum | 0x00000080
str_129          = bignum | 0x00000081
str_130          = bignum | 0x00000082
str_131          = bignum | 0x00000083
str_132          = bignum | 0x00000084
str_133          = bignum | 0x00000085
str_134          = bignum | 0x00000086
str_135          = bignum | 0x00000087
str_136          = bignum | 0x00000088
str_137          = bignum | 0x00000089
str_138          = bignum | 0x0000008a
str_139          = bignum | 0x0000008b
str_140          = bignum | 0x0000008c
str_141          = bignum | 0x0000008d
str_142          = bignum | 0x0000008e
str_143          = bignum | 0x0000008f
str_144          = bignum | 0x00000090
str_145          = bignum | 0x00000091
str_146          = bignum | 0x00000092
str_147          = bignum | 0x00000093
str_148          = bignum | 0x00000094
str_149          = bignum | 0x00000095
str_150          = bignum | 0x00000096
str_151          = bignum | 0x00000097
str_152          = bignum | 0x00000098
str_153          = bignum | 0x00000099
str_154          = bignum | 0x0000009a
str_155          = bignum | 0x0000009b
str_156          = bignum | 0x0000009c
str_157          = bignum | 0x0000009d
str_158          = bignum | 0x0000009e
str_159          = bignum | 0x0000009f
str_160          = bignum | 0x000000a0
str_161          = bignum | 0x000000a1
str_162          = bignum | 0x000000a2
str_163          = bignum | 0x000000a3
str_164          = bignum | 0x000000a4
str_165          = bignum | 0x000000a5
str_166          = bignum | 0x000000a6
str_167          = bignum | 0x000000a7
str_168          = bignum | 0x000000a8
str_169          = bignum | 0x000000a9
str_170          = bignum | 0x000000aa
str_171          = bignum | 0x000000ab
str_172          = bignum | 0x000000ac
str_173          = bignum | 0x000000ad
str_174          = bignum | 0x000000ae
str_175          = bignum | 0x000000af
str_176          = bignum | 0x000000b0
str_177          = bignum | 0x000000b1
str_178          = bignum | 0x000000b2
str_179          = bignum | 0x000000b3
str_180          = bignum | 0x000000b4
str_181          = bignum | 0x000000b5
str_182          = bignum | 0x000000b6
str_183          = bignum | 0x000000b7
str_184          = bignum | 0x000000b8
str_185          = bignum | 0x000000b9
str_186          = bignum | 0x000000ba
str_187          = bignum | 0x000000bb
str_188          = bignum | 0x000000bc
str_189          = bignum | 0x000000bd
str_190          = bignum | 0x000000be
str_191          = bignum | 0x000000bf
str_192          = bignum | 0x000000c0
str_193          = bignum | 0x000000c1
str_194          = bignum | 0x000000c2
str_195          = bignum | 0x000000c3
str_196          = bignum | 0x000000c4
str_197          = bignum | 0x000000c5
str_198          = bignum | 0x000000c6
str_199          = bignum | 0x000000c7
str_200          = bignum | 0x000000c8
str_201          = bignum | 0x000000c9
str_202          = bignum | 0x000000ca
str_203          = bignum | 0x000000cb
str_204          = bignum | 0x000000cc
str_205          = bignum | 0x000000cd
str_206          = bignum | 0x000000ce
str_207          = bignum | 0x000000cf
str_208          = bignum | 0x000000d0
str_209          = bignum | 0x000000d1
str_210          = bignum | 0x000000d2
str_211          = bignum | 0x000000d3
str_212          = bignum | 0x000000d4
str_213          = bignum | 0x000000d5
str_214          = bignum | 0x000000d6
str_215          = bignum | 0x000000d7
str_216          = bignum | 0x000000d8
str_217          = bignum | 0x000000d9
str_218          = bignum | 0x000000da
str_219          = bignum | 0x000000db
str_220          = bignum | 0x000000dc
str_221          = bignum | 0x000000dd
str_222          = bignum | 0x000000de
str_223          = bignum | 0x000000df
str_224          = bignum | 0x000000e0
str_225          = bignum | 0x000000e1
str_226          = bignum | 0x000000e2
str_227          = bignum | 0x000000e3
str_228          = bignum | 0x000000e4
str_229          = bignum | 0x000000e5
str_230          = bignum | 0x000000e6
str_231          = bignum | 0x000000e7
str_232          = bignum | 0x000000e8
str_233          = bignum | 0x000000e9
str_234          = bignum | 0x000000ea
str_235          = bignum | 0x000000eb
str_236          = bignum | 0x000000ec
str_237          = bignum | 0x000000ed
str_238          = bignum | 0x000000ee
str_239          = bignum | 0x000000ef
str_240          = bignum | 0x000000f0
str_241          = bignum | 0x000000f1
str_242          = bignum | 0x000000f2
str_243          = bignum | 0x000000f3
str_244          = bignum | 0x000000f4
str_245          = bignum | 0x000000f5
str_246          = bignum | 0x000000f6
str_247          = bignum | 0x000000f7
str_248          = bignum | 0x000000f8
str_249          = bignum | 0x000000f9
str_250          = bignum | 0x000000fa
str_251          = bignum | 0x000000fb
str_252          = bignum | 0x000000fc
str_253          = bignum | 0x000000fd
str_254          = bignum | 0x000000fe
str_255          = bignum | 0x000000ff

agi_1            = bignum | 0x00000100
agi_2            = bignum | 0x00000200
agi_3            = bignum | 0x00000300
agi_4            = bignum | 0x00000400
agi_5            = bignum | 0x00000500
agi_6            = bignum | 0x00000600
agi_7            = bignum | 0x00000700
agi_8            = bignum | 0x00000800
agi_9            = bignum | 0x00000900
agi_10           = bignum | 0x00000a00
agi_11           = bignum | 0x00000b00
agi_12           = bignum | 0x00000c00
agi_13           = bignum | 0x00000d00
agi_14           = bignum | 0x00000e00
agi_15           = bignum | 0x00000f00
agi_16           = bignum | 0x00001000
agi_17           = bignum | 0x00001100
agi_18           = bignum | 0x00001200
agi_19           = bignum | 0x00001300
agi_20           = bignum | 0x00001400
agi_21           = bignum | 0x00001500
agi_22           = bignum | 0x00001600
agi_23           = bignum | 0x00001700
agi_24           = bignum | 0x00001800
agi_25           = bignum | 0x00001900
agi_26           = bignum | 0x00001a00
agi_27           = bignum | 0x00001b00
agi_28           = bignum | 0x00001c00
agi_29           = bignum | 0x00001d00
agi_30           = bignum | 0x00001e00
agi_31           = bignum | 0x00001f00
agi_32           = bignum | 0x00002000
agi_33           = bignum | 0x00002100
agi_34           = bignum | 0x00002200
agi_35           = bignum | 0x00002300
agi_36           = bignum | 0x00002400
agi_37           = bignum | 0x00002500
agi_38           = bignum | 0x00002600
agi_39           = bignum | 0x00002700
agi_40           = bignum | 0x00002800
agi_41           = bignum | 0x00002900
agi_42           = bignum | 0x00002a00
agi_43           = bignum | 0x00002b00
agi_44           = bignum | 0x00002c00
agi_45           = bignum | 0x00002d00
agi_46           = bignum | 0x00002e00
agi_47           = bignum | 0x00002f00
agi_48           = bignum | 0x00003000
agi_49           = bignum | 0x00003100
agi_50           = bignum | 0x00003200
agi_51           = bignum | 0x00003300
agi_52           = bignum | 0x00003400
agi_53           = bignum | 0x00003500
agi_54           = bignum | 0x00003600
agi_55           = bignum | 0x00003700
agi_56           = bignum | 0x00003800
agi_57           = bignum | 0x00003900
agi_58           = bignum | 0x00003a00
agi_59           = bignum | 0x00003b00
agi_60           = bignum | 0x00003c00
agi_61           = bignum | 0x00003d00
agi_62           = bignum | 0x00003e00
agi_63           = bignum | 0x00003f00
agi_64           = bignum | 0x00004000
agi_65           = bignum | 0x00004100
agi_66           = bignum | 0x00004200
agi_67           = bignum | 0x00004300
agi_68           = bignum | 0x00004400
agi_69           = bignum | 0x00004500
agi_70           = bignum | 0x00004600
agi_71           = bignum | 0x00004700
agi_72           = bignum | 0x00004800
agi_73           = bignum | 0x00004900
agi_74           = bignum | 0x00004a00
agi_75           = bignum | 0x00004b00
agi_76           = bignum | 0x00004c00
agi_77           = bignum | 0x00004d00
agi_78           = bignum | 0x00004e00
agi_79           = bignum | 0x00004f00
agi_80           = bignum | 0x00005000
agi_81           = bignum | 0x00005100
agi_82           = bignum | 0x00005200
agi_83           = bignum | 0x00005300
agi_84           = bignum | 0x00005400
agi_85           = bignum | 0x00005500
agi_86           = bignum | 0x00005600
agi_87           = bignum | 0x00005700
agi_88           = bignum | 0x00005800
agi_89           = bignum | 0x00005900
agi_90           = bignum | 0x00005a00
agi_91           = bignum | 0x00005b00
agi_92           = bignum | 0x00005c00
agi_93           = bignum | 0x00005d00
agi_94           = bignum | 0x00005e00
agi_95           = bignum | 0x00005f00
agi_96           = bignum | 0x00006000
agi_97           = bignum | 0x00006100
agi_98           = bignum | 0x00006200
agi_99           = bignum | 0x00006300
agi_100          = bignum | 0x00006400
agi_101          = bignum | 0x00006500
agi_102          = bignum | 0x00006600
agi_103          = bignum | 0x00006700
agi_104          = bignum | 0x00006800
agi_105          = bignum | 0x00006900
agi_106          = bignum | 0x00006a00
agi_107          = bignum | 0x00006b00
agi_108          = bignum | 0x00006c00
agi_109          = bignum | 0x00006d00
agi_110          = bignum | 0x00006e00
agi_111          = bignum | 0x00006f00
agi_112          = bignum | 0x00007000
agi_113          = bignum | 0x00007100
agi_114          = bignum | 0x00007200
agi_115          = bignum | 0x00007300
agi_116          = bignum | 0x00007400
agi_117          = bignum | 0x00007500
agi_118          = bignum | 0x00007600
agi_119          = bignum | 0x00007700
agi_120          = bignum | 0x00007800
agi_121          = bignum | 0x00007900
agi_122          = bignum | 0x00007a00
agi_123          = bignum | 0x00007b00
agi_124          = bignum | 0x00007c00
agi_125          = bignum | 0x00007d00
agi_126          = bignum | 0x00007e00
agi_127          = bignum | 0x00007f00
agi_128          = bignum | 0x00008000
agi_129          = bignum | 0x00008100
agi_130          = bignum | 0x00008200
agi_131          = bignum | 0x00008300
agi_132          = bignum | 0x00008400
agi_133          = bignum | 0x00008500
agi_134          = bignum | 0x00008600
agi_135          = bignum | 0x00008700
agi_136          = bignum | 0x00008800
agi_137          = bignum | 0x00008900
agi_138          = bignum | 0x00008a00
agi_139          = bignum | 0x00008b00
agi_140          = bignum | 0x00008c00
agi_141          = bignum | 0x00008d00
agi_142          = bignum | 0x00008e00
agi_143          = bignum | 0x00008f00
agi_144          = bignum | 0x00009000
agi_145          = bignum | 0x00009100
agi_146          = bignum | 0x00009200
agi_147          = bignum | 0x00009300
agi_148          = bignum | 0x00009400
agi_149          = bignum | 0x00009500
agi_150          = bignum | 0x00009600
agi_151          = bignum | 0x00009700
agi_152          = bignum | 0x00009800
agi_153          = bignum | 0x00009900
agi_154          = bignum | 0x00009a00
agi_155          = bignum | 0x00009b00
agi_156          = bignum | 0x00009c00
agi_157          = bignum | 0x00009d00
agi_158          = bignum | 0x00009e00
agi_159          = bignum | 0x00009f00
agi_160          = bignum | 0x0000a000
agi_161          = bignum | 0x0000a100
agi_162          = bignum | 0x0000a200
agi_163          = bignum | 0x0000a300
agi_164          = bignum | 0x0000a400
agi_165          = bignum | 0x0000a500
agi_166          = bignum | 0x0000a600
agi_167          = bignum | 0x0000a700
agi_168          = bignum | 0x0000a800
agi_169          = bignum | 0x0000a900
agi_170          = bignum | 0x0000aa00
agi_171          = bignum | 0x0000ab00
agi_172          = bignum | 0x0000ac00
agi_173          = bignum | 0x0000ad00
agi_174          = bignum | 0x0000ae00
agi_175          = bignum | 0x0000af00
agi_176          = bignum | 0x0000b000
agi_177          = bignum | 0x0000b100
agi_178          = bignum | 0x0000b200
agi_179          = bignum | 0x0000b300
agi_180          = bignum | 0x0000b400
agi_181          = bignum | 0x0000b500
agi_182          = bignum | 0x0000b600
agi_183          = bignum | 0x0000b700
agi_184          = bignum | 0x0000b800
agi_185          = bignum | 0x0000b900
agi_186          = bignum | 0x0000ba00
agi_187          = bignum | 0x0000bb00
agi_188          = bignum | 0x0000bc00
agi_189          = bignum | 0x0000bd00
agi_190          = bignum | 0x0000be00
agi_191          = bignum | 0x0000bf00
agi_192          = bignum | 0x0000c000
agi_193          = bignum | 0x0000c100
agi_194          = bignum | 0x0000c200
agi_195          = bignum | 0x0000c300
agi_196          = bignum | 0x0000c400
agi_197          = bignum | 0x0000c500
agi_198          = bignum | 0x0000c600
agi_199          = bignum | 0x0000c700
agi_200          = bignum | 0x0000c800
agi_201          = bignum | 0x0000c900
agi_202          = bignum | 0x0000ca00
agi_203          = bignum | 0x0000cb00
agi_204          = bignum | 0x0000cc00
agi_205          = bignum | 0x0000cd00
agi_206          = bignum | 0x0000ce00
agi_207          = bignum | 0x0000cf00
agi_208          = bignum | 0x0000d000
agi_209          = bignum | 0x0000d100
agi_210          = bignum | 0x0000d200
agi_211          = bignum | 0x0000d300
agi_212          = bignum | 0x0000d400
agi_213          = bignum | 0x0000d500
agi_214          = bignum | 0x0000d600
agi_215          = bignum | 0x0000d700
agi_216          = bignum | 0x0000d800
agi_217          = bignum | 0x0000d900
agi_218          = bignum | 0x0000da00
agi_219          = bignum | 0x0000db00
agi_220          = bignum | 0x0000dc00
agi_221          = bignum | 0x0000dd00
agi_222          = bignum | 0x0000de00
agi_223          = bignum | 0x0000df00
agi_224          = bignum | 0x0000e000
agi_225          = bignum | 0x0000e100
agi_226          = bignum | 0x0000e200
agi_227          = bignum | 0x0000e300
agi_228          = bignum | 0x0000e400
agi_229          = bignum | 0x0000e500
agi_230          = bignum | 0x0000e600
agi_231          = bignum | 0x0000e700
agi_232          = bignum | 0x0000e800
agi_233          = bignum | 0x0000e900
agi_234          = bignum | 0x0000ea00
agi_235          = bignum | 0x0000eb00
agi_236          = bignum | 0x0000ec00
agi_237          = bignum | 0x0000ed00
agi_238          = bignum | 0x0000ee00
agi_239          = bignum | 0x0000ef00
agi_240          = bignum | 0x0000f000
agi_241          = bignum | 0x0000f100
agi_242          = bignum | 0x0000f200
agi_243          = bignum | 0x0000f300
agi_244          = bignum | 0x0000f400
agi_245          = bignum | 0x0000f500
agi_246          = bignum | 0x0000f600
agi_247          = bignum | 0x0000f700
agi_248          = bignum | 0x0000f800
agi_249          = bignum | 0x0000f900
agi_250          = bignum | 0x0000fa00
agi_251          = bignum | 0x0000fb00
agi_252          = bignum | 0x0000fc00
agi_253          = bignum | 0x0000fd00
agi_254          = bignum | 0x0000fe00
agi_255          = bignum | 0x0000ff00

int_1            = bignum | 0x00010000
int_2            = bignum | 0x00020000
int_3            = bignum | 0x00030000
int_4            = bignum | 0x00040000
int_5            = bignum | 0x00050000
int_6            = bignum | 0x00060000
int_7            = bignum | 0x00070000
int_8            = bignum | 0x00080000
int_9            = bignum | 0x00090000
int_10           = bignum | 0x000a0000
int_11           = bignum | 0x000b0000
int_12           = bignum | 0x000c0000
int_13           = bignum | 0x000d0000
int_14           = bignum | 0x000e0000
int_15           = bignum | 0x000f0000
int_16           = bignum | 0x00100000
int_17           = bignum | 0x00110000
int_18           = bignum | 0x00120000
int_19           = bignum | 0x00130000
int_20           = bignum | 0x00140000
int_21           = bignum | 0x00150000
int_22           = bignum | 0x00160000
int_23           = bignum | 0x00170000
int_24           = bignum | 0x00180000
int_25           = bignum | 0x00190000
int_26           = bignum | 0x001a0000
int_27           = bignum | 0x001b0000
int_28           = bignum | 0x001c0000
int_29           = bignum | 0x001d0000
int_30           = bignum | 0x001e0000
int_31           = bignum | 0x001f0000
int_32           = bignum | 0x00200000
int_33           = bignum | 0x00210000
int_34           = bignum | 0x00220000
int_35           = bignum | 0x00230000
int_36           = bignum | 0x00240000
int_37           = bignum | 0x00250000
int_38           = bignum | 0x00260000
int_39           = bignum | 0x00270000
int_40           = bignum | 0x00280000
int_41           = bignum | 0x00290000
int_42           = bignum | 0x002a0000
int_43           = bignum | 0x002b0000
int_44           = bignum | 0x002c0000
int_45           = bignum | 0x002d0000
int_46           = bignum | 0x002e0000
int_47           = bignum | 0x002f0000
int_48           = bignum | 0x00300000
int_49           = bignum | 0x00310000
int_50           = bignum | 0x00320000
int_51           = bignum | 0x00330000
int_52           = bignum | 0x00340000
int_53           = bignum | 0x00350000
int_54           = bignum | 0x00360000
int_55           = bignum | 0x00370000
int_56           = bignum | 0x00380000
int_57           = bignum | 0x00390000
int_58           = bignum | 0x003a0000
int_59           = bignum | 0x003b0000
int_60           = bignum | 0x003c0000
int_61           = bignum | 0x003d0000
int_62           = bignum | 0x003e0000
int_63           = bignum | 0x003f0000
int_64           = bignum | 0x00400000
int_65           = bignum | 0x00410000
int_66           = bignum | 0x00420000
int_67           = bignum | 0x00430000
int_68           = bignum | 0x00440000
int_69           = bignum | 0x00450000
int_70           = bignum | 0x00460000
int_71           = bignum | 0x00470000
int_72           = bignum | 0x00480000
int_73           = bignum | 0x00490000
int_74           = bignum | 0x004a0000
int_75           = bignum | 0x004b0000
int_76           = bignum | 0x004c0000
int_77           = bignum | 0x004d0000
int_78           = bignum | 0x004e0000
int_79           = bignum | 0x004f0000
int_80           = bignum | 0x00500000
int_81           = bignum | 0x00510000
int_82           = bignum | 0x00520000
int_83           = bignum | 0x00530000
int_84           = bignum | 0x00540000
int_85           = bignum | 0x00550000
int_86           = bignum | 0x00560000
int_87           = bignum | 0x00570000
int_88           = bignum | 0x00580000
int_89           = bignum | 0x00590000
int_90           = bignum | 0x005a0000
int_91           = bignum | 0x005b0000
int_92           = bignum | 0x005c0000
int_93           = bignum | 0x005d0000
int_94           = bignum | 0x005e0000
int_95           = bignum | 0x005f0000
int_96           = bignum | 0x00600000
int_97           = bignum | 0x00610000
int_98           = bignum | 0x00620000
int_99           = bignum | 0x00630000
int_100          = bignum | 0x00640000
int_101          = bignum | 0x00650000
int_102          = bignum | 0x00660000
int_103          = bignum | 0x00670000
int_104          = bignum | 0x00680000
int_105          = bignum | 0x00690000
int_106          = bignum | 0x006a0000
int_107          = bignum | 0x006b0000
int_108          = bignum | 0x006c0000
int_109          = bignum | 0x006d0000
int_110          = bignum | 0x006e0000
int_111          = bignum | 0x006f0000
int_112          = bignum | 0x00700000
int_113          = bignum | 0x00710000
int_114          = bignum | 0x00720000
int_115          = bignum | 0x00730000
int_116          = bignum | 0x00740000
int_117          = bignum | 0x00750000
int_118          = bignum | 0x00760000
int_119          = bignum | 0x00770000
int_120          = bignum | 0x00780000
int_121          = bignum | 0x00790000
int_122          = bignum | 0x007a0000
int_123          = bignum | 0x007b0000
int_124          = bignum | 0x007c0000
int_125          = bignum | 0x007d0000
int_126          = bignum | 0x007e0000
int_127          = bignum | 0x007f0000
int_128          = bignum | 0x00800000
int_129          = bignum | 0x00810000
int_130          = bignum | 0x00820000
int_131          = bignum | 0x00830000
int_132          = bignum | 0x00840000
int_133          = bignum | 0x00850000
int_134          = bignum | 0x00860000
int_135          = bignum | 0x00870000
int_136          = bignum | 0x00880000
int_137          = bignum | 0x00890000
int_138          = bignum | 0x008a0000
int_139          = bignum | 0x008b0000
int_140          = bignum | 0x008c0000
int_141          = bignum | 0x008d0000
int_142          = bignum | 0x008e0000
int_143          = bignum | 0x008f0000
int_144          = bignum | 0x00900000
int_145          = bignum | 0x00910000
int_146          = bignum | 0x00920000
int_147          = bignum | 0x00930000
int_148          = bignum | 0x00940000
int_149          = bignum | 0x00950000
int_150          = bignum | 0x00960000
int_151          = bignum | 0x00970000
int_152          = bignum | 0x00980000
int_153          = bignum | 0x00990000
int_154          = bignum | 0x009a0000
int_155          = bignum | 0x009b0000
int_156          = bignum | 0x009c0000
int_157          = bignum | 0x009d0000
int_158          = bignum | 0x009e0000
int_159          = bignum | 0x009f0000
int_160          = bignum | 0x00a00000
int_161          = bignum | 0x00a10000
int_162          = bignum | 0x00a20000
int_163          = bignum | 0x00a30000
int_164          = bignum | 0x00a40000
int_165          = bignum | 0x00a50000
int_166          = bignum | 0x00a60000
int_167          = bignum | 0x00a70000
int_168          = bignum | 0x00a80000
int_169          = bignum | 0x00a90000
int_170          = bignum | 0x00aa0000
int_171          = bignum | 0x00ab0000
int_172          = bignum | 0x00ac0000
int_173          = bignum | 0x00ad0000
int_174          = bignum | 0x00ae0000
int_175          = bignum | 0x00af0000
int_176          = bignum | 0x00b00000
int_177          = bignum | 0x00b10000
int_178          = bignum | 0x00b20000
int_179          = bignum | 0x00b30000
int_180          = bignum | 0x00b40000
int_181          = bignum | 0x00b50000
int_182          = bignum | 0x00b60000
int_183          = bignum | 0x00b70000
int_184          = bignum | 0x00b80000
int_185          = bignum | 0x00b90000
int_186          = bignum | 0x00ba0000
int_187          = bignum | 0x00bb0000
int_188          = bignum | 0x00bc0000
int_189          = bignum | 0x00bd0000
int_190          = bignum | 0x00be0000
int_191          = bignum | 0x00bf0000
int_192          = bignum | 0x00c00000
int_193          = bignum | 0x00c10000
int_194          = bignum | 0x00c20000
int_195          = bignum | 0x00c30000
int_196          = bignum | 0x00c40000
int_197          = bignum | 0x00c50000
int_198          = bignum | 0x00c60000
int_199          = bignum | 0x00c70000
int_200          = bignum | 0x00c80000
int_201          = bignum | 0x00c90000
int_202          = bignum | 0x00ca0000
int_203          = bignum | 0x00cb0000
int_204          = bignum | 0x00cc0000
int_205          = bignum | 0x00cd0000
int_206          = bignum | 0x00ce0000
int_207          = bignum | 0x00cf0000
int_208          = bignum | 0x00d00000
int_209          = bignum | 0x00d10000
int_210          = bignum | 0x00d20000
int_211          = bignum | 0x00d30000
int_212          = bignum | 0x00d40000
int_213          = bignum | 0x00d50000
int_214          = bignum | 0x00d60000
int_215          = bignum | 0x00d70000
int_216          = bignum | 0x00d80000
int_217          = bignum | 0x00d90000
int_218          = bignum | 0x00da0000
int_219          = bignum | 0x00db0000
int_220          = bignum | 0x00dc0000
int_221          = bignum | 0x00dd0000
int_222          = bignum | 0x00de0000
int_223          = bignum | 0x00df0000
int_224          = bignum | 0x00e00000
int_225          = bignum | 0x00e10000
int_226          = bignum | 0x00e20000
int_227          = bignum | 0x00e30000
int_228          = bignum | 0x00e40000
int_229          = bignum | 0x00e50000
int_230          = bignum | 0x00e60000
int_231          = bignum | 0x00e70000
int_232          = bignum | 0x00e80000
int_233          = bignum | 0x00e90000
int_234          = bignum | 0x00ea0000
int_235          = bignum | 0x00eb0000
int_236          = bignum | 0x00ec0000
int_237          = bignum | 0x00ed0000
int_238          = bignum | 0x00ee0000
int_239          = bignum | 0x00ef0000
int_240          = bignum | 0x00f00000
int_241          = bignum | 0x00f10000
int_242          = bignum | 0x00f20000
int_243          = bignum | 0x00f30000
int_244          = bignum | 0x00f40000
int_245          = bignum | 0x00f50000
int_246          = bignum | 0x00f60000
int_247          = bignum | 0x00f70000
int_248          = bignum | 0x00f80000
int_249          = bignum | 0x00f90000
int_250          = bignum | 0x00fa0000
int_251          = bignum | 0x00fb0000
int_252          = bignum | 0x00fc0000
int_253          = bignum | 0x00fd0000
int_254          = bignum | 0x00fe0000
int_255          = bignum | 0x00ff0000

cha_1            = bignum | 0x01000000
cha_2            = bignum | 0x02000000
cha_3            = bignum | 0x03000000
cha_4            = bignum | 0x04000000
cha_5            = bignum | 0x05000000
cha_6            = bignum | 0x06000000
cha_7            = bignum | 0x07000000
cha_8            = bignum | 0x08000000
cha_9            = bignum | 0x09000000
cha_10           = bignum | 0x0a000000
cha_11           = bignum | 0x0b000000
cha_12           = bignum | 0x0c000000
cha_13           = bignum | 0x0d000000
cha_14           = bignum | 0x0e000000
cha_15           = bignum | 0x0f000000
cha_16           = bignum | 0x10000000
cha_17           = bignum | 0x11000000
cha_18           = bignum | 0x12000000
cha_19           = bignum | 0x13000000
cha_20           = bignum | 0x14000000
cha_21           = bignum | 0x15000000
cha_22           = bignum | 0x16000000
cha_23           = bignum | 0x17000000
cha_24           = bignum | 0x18000000
cha_25           = bignum | 0x19000000
cha_26           = bignum | 0x1a000000
cha_27           = bignum | 0x1b000000
cha_28           = bignum | 0x1c000000
cha_29           = bignum | 0x1d000000
cha_30           = bignum | 0x1e000000
cha_31           = bignum | 0x1f000000
cha_32           = bignum | 0x20000000
cha_33           = bignum | 0x21000000
cha_34           = bignum | 0x22000000
cha_35           = bignum | 0x23000000
cha_36           = bignum | 0x24000000
cha_37           = bignum | 0x25000000
cha_38           = bignum | 0x26000000
cha_39           = bignum | 0x27000000
cha_40           = bignum | 0x28000000
cha_41           = bignum | 0x29000000
cha_42           = bignum | 0x2a000000
cha_43           = bignum | 0x2b000000
cha_44           = bignum | 0x2c000000
cha_45           = bignum | 0x2d000000
cha_46           = bignum | 0x2e000000
cha_47           = bignum | 0x2f000000
cha_48           = bignum | 0x30000000
cha_49           = bignum | 0x31000000
cha_50           = bignum | 0x32000000
cha_51           = bignum | 0x33000000
cha_52           = bignum | 0x34000000
cha_53           = bignum | 0x35000000
cha_54           = bignum | 0x36000000
cha_55           = bignum | 0x37000000
cha_56           = bignum | 0x38000000
cha_57           = bignum | 0x39000000
cha_58           = bignum | 0x3a000000
cha_59           = bignum | 0x3b000000
cha_60           = bignum | 0x3c000000
cha_61           = bignum | 0x3d000000
cha_62           = bignum | 0x3e000000
cha_63           = bignum | 0x3f000000
cha_64           = bignum | 0x40000000
cha_65           = bignum | 0x41000000
cha_66           = bignum | 0x42000000
cha_67           = bignum | 0x43000000
cha_68           = bignum | 0x44000000
cha_69           = bignum | 0x45000000
cha_70           = bignum | 0x46000000
cha_71           = bignum | 0x47000000
cha_72           = bignum | 0x48000000
cha_73           = bignum | 0x49000000
cha_74           = bignum | 0x4a000000
cha_75           = bignum | 0x4b000000
cha_76           = bignum | 0x4c000000
cha_77           = bignum | 0x4d000000
cha_78           = bignum | 0x4e000000
cha_79           = bignum | 0x4f000000
cha_80           = bignum | 0x50000000
cha_81           = bignum | 0x51000000
cha_82           = bignum | 0x52000000
cha_83           = bignum | 0x53000000
cha_84           = bignum | 0x54000000
cha_85           = bignum | 0x55000000
cha_86           = bignum | 0x56000000
cha_87           = bignum | 0x57000000
cha_88           = bignum | 0x58000000
cha_89           = bignum | 0x59000000
cha_90           = bignum | 0x5a000000
cha_91           = bignum | 0x5b000000
cha_92           = bignum | 0x5c000000
cha_93           = bignum | 0x5d000000
cha_94           = bignum | 0x5e000000
cha_95           = bignum | 0x5f000000
cha_96           = bignum | 0x60000000
cha_97           = bignum | 0x61000000
cha_98           = bignum | 0x62000000
cha_99           = bignum | 0x63000000
cha_100          = bignum | 0x64000000
cha_101          = bignum | 0x65000000
cha_102          = bignum | 0x66000000
cha_103          = bignum | 0x67000000
cha_104          = bignum | 0x68000000
cha_105          = bignum | 0x69000000
cha_106          = bignum | 0x6a000000
cha_107          = bignum | 0x6b000000
cha_108          = bignum | 0x6c000000
cha_109          = bignum | 0x6d000000
cha_110          = bignum | 0x6e000000
cha_111          = bignum | 0x6f000000
cha_112          = bignum | 0x70000000
cha_113          = bignum | 0x71000000
cha_114          = bignum | 0x72000000
cha_115          = bignum | 0x73000000
cha_116          = bignum | 0x74000000
cha_117          = bignum | 0x75000000
cha_118          = bignum | 0x76000000
cha_119          = bignum | 0x77000000
cha_120          = bignum | 0x78000000
cha_121          = bignum | 0x79000000
cha_122          = bignum | 0x7a000000
cha_123          = bignum | 0x7b000000
cha_124          = bignum | 0x7c000000
cha_125          = bignum | 0x7d000000
cha_126          = bignum | 0x7e000000
cha_127          = bignum | 0x7f000000
cha_128          = bignum | 0x80000000
cha_129          = bignum | 0x81000000
cha_130          = bignum | 0x82000000
cha_131          = bignum | 0x83000000
cha_132          = bignum | 0x84000000
cha_133          = bignum | 0x85000000
cha_134          = bignum | 0x86000000
cha_135          = bignum | 0x87000000
cha_136          = bignum | 0x88000000
cha_137          = bignum | 0x89000000
cha_138          = bignum | 0x8a000000
cha_139          = bignum | 0x8b000000
cha_140          = bignum | 0x8c000000
cha_141          = bignum | 0x8d000000
cha_142          = bignum | 0x8e000000
cha_143          = bignum | 0x8f000000
cha_144          = bignum | 0x90000000
cha_145          = bignum | 0x91000000
cha_146          = bignum | 0x92000000
cha_147          = bignum | 0x93000000
cha_148          = bignum | 0x94000000
cha_149          = bignum | 0x95000000
cha_150          = bignum | 0x96000000
cha_151          = bignum | 0x97000000
cha_152          = bignum | 0x98000000
cha_153          = bignum | 0x99000000
cha_154          = bignum | 0x9a000000
cha_155          = bignum | 0x9b000000
cha_156          = bignum | 0x9c000000
cha_157          = bignum | 0x9d000000
cha_158          = bignum | 0x9e000000
cha_159          = bignum | 0x9f000000
cha_160          = bignum | 0xa0000000
cha_161          = bignum | 0xa1000000
cha_162          = bignum | 0xa2000000
cha_163          = bignum | 0xa3000000
cha_164          = bignum | 0xa4000000
cha_165          = bignum | 0xa5000000
cha_166          = bignum | 0xa6000000
cha_167          = bignum | 0xa7000000
cha_168          = bignum | 0xa8000000
cha_169          = bignum | 0xa9000000
cha_170          = bignum | 0xaa000000
cha_171          = bignum | 0xab000000
cha_172          = bignum | 0xac000000
cha_173          = bignum | 0xad000000
cha_174          = bignum | 0xae000000
cha_175          = bignum | 0xaf000000
cha_176          = bignum | 0xb0000000
cha_177          = bignum | 0xb1000000
cha_178          = bignum | 0xb2000000
cha_179          = bignum | 0xb3000000
cha_180          = bignum | 0xb4000000
cha_181          = bignum | 0xb5000000
cha_182          = bignum | 0xb6000000
cha_183          = bignum | 0xb7000000
cha_184          = bignum | 0xb8000000
cha_185          = bignum | 0xb9000000
cha_186          = bignum | 0xba000000
cha_187          = bignum | 0xbb000000
cha_188          = bignum | 0xbc000000
cha_189          = bignum | 0xbd000000
cha_190          = bignum | 0xbe000000
cha_191          = bignum | 0xbf000000
cha_192          = bignum | 0xc0000000
cha_193          = bignum | 0xc1000000
cha_194          = bignum | 0xc2000000
cha_195          = bignum | 0xc3000000
cha_196          = bignum | 0xc4000000
cha_197          = bignum | 0xc5000000
cha_198          = bignum | 0xc6000000
cha_199          = bignum | 0xc7000000
cha_200          = bignum | 0xc8000000
cha_201          = bignum | 0xc9000000
cha_202          = bignum | 0xca000000
cha_203          = bignum | 0xcb000000
cha_204          = bignum | 0xcc000000
cha_205          = bignum | 0xcd000000
cha_206          = bignum | 0xce000000
cha_207          = bignum | 0xcf000000
cha_208          = bignum | 0xd0000000
cha_209          = bignum | 0xd1000000
cha_210          = bignum | 0xd2000000
cha_211          = bignum | 0xd3000000
cha_212          = bignum | 0xd4000000
cha_213          = bignum | 0xd5000000
cha_214          = bignum | 0xd6000000
cha_215          = bignum | 0xd7000000
cha_216          = bignum | 0xd8000000
cha_217          = bignum | 0xd9000000
cha_218          = bignum | 0xda000000
cha_219          = bignum | 0xdb000000
cha_220          = bignum | 0xdc000000
cha_221          = bignum | 0xdd000000
cha_222          = bignum | 0xde000000
cha_223          = bignum | 0xdf000000
cha_224          = bignum | 0xe0000000
cha_225          = bignum | 0xe1000000
cha_226          = bignum | 0xe2000000
cha_227          = bignum | 0xe3000000
cha_228          = bignum | 0xe4000000
cha_229          = bignum | 0xe5000000
cha_230          = bignum | 0xe6000000
cha_231          = bignum | 0xe7000000
cha_232          = bignum | 0xe8000000
cha_233          = bignum | 0xe9000000
cha_234          = bignum | 0xea000000
cha_235          = bignum | 0xeb000000
cha_236          = bignum | 0xec000000
cha_237          = bignum | 0xed000000
cha_238          = bignum | 0xee000000
cha_239          = bignum | 0xef000000
cha_240          = bignum | 0xf0000000
cha_241          = bignum | 0xf1000000
cha_242          = bignum | 0xf2000000
cha_243          = bignum | 0xf3000000
cha_244          = bignum | 0xf4000000
cha_245          = bignum | 0xf5000000
cha_246          = bignum | 0xf6000000
cha_247          = bignum | 0xf7000000
cha_248          = bignum | 0xf8000000
cha_249          = bignum | 0xf9000000
cha_250          = bignum | 0xfa000000
cha_251          = bignum | 0xfb000000
cha_252          = bignum | 0xfc000000
cha_253          = bignum | 0xfd000000
cha_254          = bignum | 0xfe000000
cha_255          = bignum | 0xff000000

level_mask       = 0x000000FF
level_bits       = 32

def level(v):
  if (v > level_mask):
    v = level_mask
  return (bignum|v) << level_bits
  
def_attrib = str_5 | agi_5 | int_4 | cha_4

# Weapon proficiencies:
one_handed_bits = 0
two_handed_bits = 10
polearm_bits    = 20
archery_bits    = 30
crossbow_bits   = 40
throwing_bits   = 50
firearm_bits    = 60

num_weapon_proficiencies = 7
def wp_one_handed(x):
  return (((bignum | x) & 0x3FF) << one_handed_bits)
def wp_two_handed(x):
  return (((bignum | x) & 0x3FF) << two_handed_bits)
def wp_polearm(x):
  return (((bignum | x) & 0x3FF) << polearm_bits)
def wp_archery(x):
  return (((bignum | x) & 0x3FF) << archery_bits)
def wp_crossbow(x):
  return (((bignum | x) & 0x3FF) << crossbow_bits)
def wp_throwing(x):
  return (((bignum | x) & 0x3FF) << throwing_bits)
def wp_firearm(x):
  return (((bignum | x) & 0x3FF) << firearm_bits)

def find_troop(troops,troop_id):
  result = -1
  num_troops = len(troops)
  i_troop = 0
  while (i_troop < num_troops) and (result == -1):
    troop = troops[i_troop]
    if (troop[0] == troop_id):
      result = i_troop
    else:
      i_troop += 1
  return result



def upgrade(troops,troop1_id,troop2_id):
  troop1_no = find_troop(troops,troop1_id)
  troop2_no = find_troop(troops,troop2_id)
  if (troop1_no == -1):
    print "Error with upgrade def: Unable to find troop1-id: " + troop1_id
  elif (troop2_no == -1):
    print "Error with upgrade def: Unable to find troop2-id: " + troop2_id
  else:
    cur_troop = troops[troop1_no]
    cur_troop_length = len(cur_troop)
    if cur_troop_length == 11:
      cur_troop[11:11] = [0, 0, 0, troop2_no, 0]
    elif cur_troop_length == 12:
      cur_troop[12:12] = [0, 0, troop2_no, 0]
    elif cur_troop_length == 13:
      cur_troop[13:13] = [0, troop2_no, 0]
    else:
      cur_troop[14:14] = [troop2_no, 0]
      

def upgrade2(troops,troop1_id,troop2_id,troop3_id):
  troop1_no = find_troop(troops,troop1_id)
  troop2_no = find_troop(troops,troop2_id)
  troop3_no = find_troop(troops,troop3_id)
  if (troop1_no == -1):
    print "Error with upgrade2 def: Unable to find troop1-id: " + troop1_id
  elif (troop2_no == -1):
    print "Error with upgrade2 def: Unable to find troop2-id: " + troop2_id
  elif (troop3_no == -1):
    print "Error with upgrade2 def: Unable to find troop3-id: " + troop3_id
  else:
    cur_troop = troops[troop1_no]
    cur_troop_length = len(cur_troop)
    if cur_troop_length == 11:
      cur_troop[11:11] = [0, 0, 0, troop2_no, troop3_no]
    elif cur_troop_length == 12:
      cur_troop[12:12] = [0, 0, troop2_no, troop3_no]
    elif cur_troop_length == 13:
      cur_troop[13:13] = [0, troop2_no, troop3_no]
    else:
      cur_troop[14:14] = [troop2_no, troop3_no]
