from header_music import *
####################################################################################################################
#  Each track record contains the following fields:
#  1) Track id: used for referencing tracks.
#  2) Track file: filename of the track
#  3) Track flags. See header_music.py for a list of available flags
#  4) Continue Track flags: Shows in which situations or cultures the track can continue playing. See header_music.py for a list of available flags
####################################################################################################################

# WARNING: You MUST add mtf_module_track flag to the flags of the tracks located under module directory

tracks = [

  ("bogus", "cant_find_this.ogg", 0, 0),
  ("mount_and_blade_title_screen", "requiem_aeternam.ogg", mtf_sit_main_title|mtf_start_immediately|mtf_module_track, 0),

  # ("ambushed_by_neutral", "ambushed_by_neutral.ogg", mtf_sit_ambushed,0),
  # ("ambushed_by_khergit", "ambushed_by_khergit.ogg", mtf_sit_ambushed,0),
  # ("ambushed_by_nord",    "ambushed_by_nord.ogg", mtf_sit_ambushed,0),
  # ("ambushed_by_rhodok",  "ambushed_by_rhodok.ogg", mtf_sit_ambushed,0),
  # ("ambushed_by_swadian", "ambushed_by_swadian.ogg", mtf_sit_ambushed,0),
  # ("ambushed_by_vaegir",  "ambushed_by_vaegir.ogg", mtf_sit_ambushed,0),

  #("arena_1", "arena_1.ogg", mtf_sit_arena, 0),
#  ("arena_2", "arena_2.ogg", mtf_looping|mtf_sit_arena, 0),
  # ("armorer", "armorer.ogg", mtf_sit_travel, 0),
  # ("bandit_fight", "bandit_fight.ogg", mtf_sit_ambushed, 0),

  # ("calm_night_1", "calm_night_2.ogg", mtf_sit_night, mtf_sit_town|mtf_sit_travel,0),
  ("captured", "capture.ogg", mtf_persist_until_finished, 0),
  ("defeated_by_neutral", "defeated_by_neutral.ogg",mtf_persist_until_finished|mtf_sit_killed, 0),
  # ("defeated_by_neutral_2", "defeated_by_neutral_2.ogg", mtf_persist_until_finished|mtf_sit_killed, 0),
  # ("defeated_by_neutral_3", "defeated_by_neutral_3.ogg", mtf_persist_until_finished|mtf_sit_killed, 0),

  ("empty_village", "empty_village.ogg", mtf_persist_until_finished, 0),
  # ("encounter_hostile_nords", "encounter_hostile_nords.ogg", mtf_persist_until_finished|mtf_sit_encounter_hostile, 0),
  ("escape", "escape.ogg", mtf_persist_until_finished, 0),

  ("fight_1", "fight_1.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege|mtf_sit_travel, 0),
  ("fight_2", "fight_2.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege|mtf_sit_travel, 0),
  ("fight_3", "fight_3.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege|mtf_sit_travel, 0),
  ("fight_4", "fight_4.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege|mtf_sit_travel, 0),  
  ("fight_5", "fight_5.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege|mtf_sit_travel, 0),  
  # ("fight_as_khergit", "fight_as_khergit.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0),
  # ("fight_as_khergit2", "fight_as_khergit2.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0),  
  # ("fight_as_nord", "fight_as_nord.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0),
  # ("fight_as_rhodok", "fight_as_rhodok.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0),
   # ("fight_as_rhodok2", "fight_as_rhodok2.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0), 
  # ("fight_as_vaegir", "fight_as_vaegir.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0),
   # ("fight_as_vaegir2", "fight_as_vaegir2.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0), 
  # ("fight_while_mounted_1", "fight_while_mounted_1.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0),
  # ("fight_while_mounted_2", "fight_while_mounted_2.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0),
  # ("fight_while_mounted_3", "fight_while_mounted_3.ogg", mtf_sit_fight|mtf_sit_multiplayer_fight|mtf_sit_ambushed|mtf_module_track|mtf_sit_siege, 0),  
  
  # ("infiltration_khergit", "infiltration_khergit.ogg", mtf_sit_town_infiltrate, mtf_culture_all),

  # ("killed_by_khergit", "killed_by_khergit.ogg", mtf_persist_until_finished|mtf_culture_of_khergits|mtf_sit_killed, 0),
#  ("killed_by_neutral", "killed_by_neutral.ogg", mtf_persist_until_finished|mtf_culture_of_sarranids|mtf_sit_killed, 0),
#  ("killed_by_nord", "killed_by_nord.ogg", mtf_persist_until_finished|mtf_culture_of_nords|mtf_sit_killed, 0),
#  ("killed_by_rhodok", "killed_by_rhodok.ogg", mtf_persist_until_finished|mtf_culture_of_rhodoks|mtf_sit_killed, 0),
  # ("killed_by_swadian", "killed_by_swadian.ogg", mtf_persist_until_finished|mtf_culture_of_swadians|mtf_sit_killed, 0),
#  ("killed_by_vaegir", "killed_by_vaegir.ogg", mtf_persist_until_finished|mtf_culture_of_vaegirs|mtf_sit_killed, 0),
  
  # ("lords_hall_khergit", "lords_hall_khergit.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
  # ("lords_hall_nord", "lords_hall_nord.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night),
  # ("lords_hall_swadian", "lords_hall_swadian.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night),
  # ("lords_hall_rhodok", "lords_hall_rhodok.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night),
  # ("lords_hall_vaegir", "lords_hall_vaegir.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night),

  # ("mounted_snow_terrain_calm", "mounted_snow_terrain_calm.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night),
  ("neutral_infiltration", "neutral_infiltration.ogg", mtf_sit_town_infiltrate, 0),
  # ("outdoor_beautiful_land", "outdoor_beautiful_land.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night),
  ("retreat", "retreat.ogg", mtf_persist_until_finished|mtf_sit_killed, 0),

  # ("seige_neutral", "seige_neutral.ogg", mtf_sit_siege, 0),

  ("tavern_1", "tavern_1.ogg", mtf_sit_tavern|mtf_sit_feast|mtf_module_track, 0),
  ("tavern_2", "tavern_2.ogg", mtf_sit_tavern|mtf_sit_feast|mtf_module_track, 0),
  ("tavern_3", "tavern_3.ogg", mtf_sit_tavern|mtf_sit_feast|mtf_module_track, 0),
  ("tavern_4", "tavern_4.ogg", mtf_sit_tavern|mtf_sit_feast|mtf_module_track, 0),
  ("tavern_5", "tavern_5.ogg", mtf_sit_tavern|mtf_sit_feast|mtf_module_track, 0),
  ("tavern_6", "tavern_6.ogg", mtf_sit_tavern|mtf_sit_feast|mtf_module_track, 0),

  # ("town_neutral", "town_neutral.ogg", mtf_sit_town|mtf_sit_travel, mtf_sit_night),
  # ("town_khergit", "town_khergit.ogg", mtf_culture_of_khergits|mtf_sit_town|mtf_sit_travel, mtf_sit_night|mtf_culture_all),
  # ("town_nord", "town_nord.ogg", mtf_culture_of_nords|mtf_sit_town|mtf_sit_travel, mtf_sit_night|mtf_culture_all),
  # ("town_rhodok", "town_rhodok.ogg", mtf_culture_of_rhodoks|mtf_sit_town|mtf_sit_travel, mtf_sit_night|mtf_culture_all),
  # ("town_swadian", "town_swadian.ogg", mtf_culture_of_swadians|mtf_sit_town|mtf_sit_travel, mtf_sit_night|mtf_culture_all),
  # ("town_vaegir", "town_vaegir.ogg", mtf_culture_of_vaegirs|mtf_sit_town|mtf_sit_travel, mtf_sit_night|mtf_culture_all),

  # ("travel_khergit", "travel_khergit.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
  # ("travel_neutral", "travel_neutral.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
  # ("travel_nord",    "travel_nord.ogg",    mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
  # ("travel_rhodok",  "travel_rhodok.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
  # ("travel_swadian", "travel_swadian.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
  # ("travel_vaegir",  "travel_vaegir.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
   # ("middle_eastern_action",  "middle_eastern_action.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all), 
   # ("warband_action",  "warband_action.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all), 
   # ("tragic_village",  "tragic_village.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),  
   # ("middle_eastern_travel",  "middle_eastern_travel.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),   
   # ("crazy_battle_music",  "crazy_battle_music.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
   # ("warband_siege",  "warband_siege.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
   # ("siege_attempt",  "siege_attempt.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),
   # ("hearth_and_brotherhood",  "hearth_and_brotherhood.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),  
   # ("enter_the_juggernaut",  "enter_the_juggernaut.ogg",  mtf_sit_travel, mtf_sit_town|mtf_sit_night|mtf_culture_all),    

  # ("uncertain_homestead", "uncertain_homestead.ogg", mtf_sit_travel, mtf_sit_town|mtf_sit_night),

  ("victorious_evil", "victorious_evil.ogg", mtf_persist_until_finished, 0),
  ("victorious_neutral_1", "victorious_neutral_1.ogg", mtf_persist_until_finished|mtf_sit_victorious, 0),
  ("victorious_neutral_2", "victorious_neutral_2.ogg", mtf_persist_until_finished|mtf_sit_victorious, 0),
  ("victorious_neutral_3", "victorious_neutral_3.ogg", mtf_persist_until_finished|mtf_sit_victorious, 0),

  ("victorious_swadian", "victorious_swadian.ogg", mtf_persist_until_finished|mtf_culture_of_vaegirs|mtf_sit_victorious, 0),
  ("victorious_vaegir", "victorious_vaegir.ogg", mtf_persist_until_finished|mtf_culture_of_vaegirs|mtf_sit_victorious, 0),
  ("victorious_vaegir_2", "victorious_vaegir_2.ogg", mtf_persist_until_finished|mtf_culture_of_vaegirs|mtf_sit_victorious, 0),
  ("wedding", "wedding.ogg", mtf_persist_until_finished, 0),
]
