from header_common import *
from header_parties import *
from ID_troops import *
from ID_factions import *
from ID_map_icons import *

pmf_is_prisoner = 0x0001

####################################################################################################################
#  Each party template record contains the following fields:
#  1) Party-template id: used for referencing party-templates in other files.
#     The prefix pt_ is automatically added before each party-template id.
#  2) Party-template name.
#  3) Party flags. See header_parties.py for a list of available flags
#  4) Menu. ID of the menu to use when this party is met. The value 0 uses the default party encounter system.
#  5) Faction
#  6) Personality. See header_parties.py for an explanation of personality flags.
#  7) List of stacks. Each stack record is a tuple that contains the following fields:
#    7.1) Troop-id. 
#    7.2) Minimum number of troops in the stack. 
#    7.3) Maximum number of troops in the stack. 
#    7.4) Member flags(optional). Use pmf_is_prisoner to note that this member is a prisoner.
#     Note: There can be at most 6 stacks.
####################################################################################################################


party_templates = [
  ("none","none",icon_gray_knight,0,fac_commoners,merchant_personality,[]),
  ("rescued_prisoners","Rescued Prisoners",icon_gray_knight,0,fac_commoners,merchant_personality,[]),
  ("enemy","Enemy",icon_gray_knight,0,fac_undeads,merchant_personality,[]),
  ("hero_party","Hero Party",icon_gray_knight,0,fac_commoners,soldier_personality,[]),
####################################################################################################################
# Party templates before this point are hard-wired into the game and should not be changed. 
####################################################################################################################
	#Special player "respawn" to get around Aleph bugs...
	("player_respawn","Player Respawn",icon_peasant,0,fac_commoners,merchant_personality,[(trp_player,1,1)]),
	
	#Special Stuff, leave me alone	
	("village_defenders","Village Defenders",icon_peasant,0,fac_commoners,merchant_personality,[(trp_farmer,10,20),(trp_peasant_woman,0,4)]),

	("cattle_herd","Cattle Herd",icon_cattle|carries_goods(10),0,fac_neutral,escorted_merchant_personality,[(trp_cattle,80,120)]),


	#These are special starting forces for certain character types.
	("mercenary_archer_starting_force","Starting Force",icon_khergit|carries_goods(2),0,fac_commoners,soldier_personality,[(trp_forest_bandit,3,5),(trp_forest_bandit_normal,1,3)]),
	("man_at_arms_starting_force","Starting Force",icon_khergit|carries_goods(2),0,fac_commoners,soldier_personality,[(trp_swadian_maceman_regular,3,4)]), 
	("brigand_starting_force","Assorted Scum",icon_axeman|carries_goods(8),0,fac_commoners,soldier_personality,[(trp_looter,5,10),(trp_looter_normal,3,5),(trp_bandit_normal,3,5),(trp_brigand_normal,3,4)]),

	#Manhunters 
	("manhunters","Manhunters",icon_lav_messenger|carries_goods(8),0,fac_manhunters,soldier_personality,[(trp_manhunter,60,200),(trp_slave_driver,45,100),(trp_slave_hunter,40,100),(trp_slave_crusher,35,65),(trp_slaver_chief,30,50)]),

	#RANDOM BAD GUYS BEGIN
	("random_bad_guys_begin","Bad Guys Begin (Placeholder)",icon_cattle|carries_goods(10),0,fac_neutral,escorted_merchant_personality,[(trp_cattle,80,120)]),

	#Looters and suchlike	  
	("looters","Looters",icon_axeman|carries_goods(8),0,fac_outlaws,bandit_personality,[(trp_looter,10,120),(trp_looter_normal,5,15)]),
	("looters_normal","Assorted Scum",icon_axeman|carries_goods(8),0,fac_outlaws,bandit_personality,[(trp_looter,7,60),(trp_looter_normal,7,60),(trp_bandit_normal,5,15),(trp_brigand_normal,5,15)]),  
	("looters_hard","Pack of Villains",icon_axeman|carries_goods(8),0,fac_outlaws,bandit_personality,[(trp_looter,20,45),(trp_looter_normal,20,45),(trp_looter_hard,20,45),(trp_bandit_hard,20,30),(trp_brigand_hard,20,30)]),   

	#Steppe Bandits
	("steppe_bandits","Steppe Bandits",icon_lav_horseman_khergit|carries_goods(2),0,fac_steppe_bandits,bandit_personality,[(trp_steppe_bandit,10,120),(trp_steppe_bandit_normal,1,10)]),
	("steppe_bandits_normal","Small Bandit Horde",icon_lav_horseman_khergit|carries_goods(2),0,fac_steppe_bandits,bandit_personality,[(trp_steppe_bandit,10,120),(trp_steppe_bandit_normal,10,120)]),  
	("steppe_bandits_hard","Large Bandit Horde",icon_lav_horseman_khergit|carries_goods(2),0,fac_steppe_bandits,bandit_personality,[(trp_steppe_bandit,20,120),(trp_steppe_bandit_normal,20,120),(trp_steppe_bandit_hard,20,120),(trp_khergit_chu_ko_nu,5,15),(trp_khergit_rocketeer_elite,15,25)]),

	#Taiga Bandits
	("taiga_bandits","Taiga Bandits",icon_lav_infantry_medium|carries_goods(2),0,fac_taiga_bandits,bandit_personality,[(trp_ruski_soldat,10,120),(trp_ruski_soldat_normal,1,10)]),
	("taiga_bandits_normal","Taiga Horde",icon_lav_infantry_medium|carries_goods(2),0,fac_taiga_bandits,bandit_personality,[(trp_ruski_soldat,10,120),(trp_ruski_soldat_normal,10,120)]),  
	("taiga_bandits_hard","Large Taiga Horde",icon_lav_infantry_medium|carries_goods(2),0,fac_taiga_bandits,bandit_personality,[(trp_ruski_soldat,20,120),(trp_ruski_soldat_normal,20,120),(trp_ruski_soldat_hard,20,120),(trp_sarranid_cataphracts,5,15),(trp_khergit_rocketeer_elite,15,25)]),

	#Desert Bandits
	("desert_bandits","Desert Bandits",icon_khergit|carries_goods(2),0,fac_desert_bandits,bandit_personality,[(trp_desert_bandit,10,120),(trp_desert_bandit_normal,1,10)]),
	("desert_bandits_normal","Desert Horde",icon_khergit|carries_goods(2),0,fac_desert_bandits,bandit_personality,[(trp_desert_bandit,10,120),(trp_desert_bandit_normal,10,120)]), 
	("desert_bandits_hard","Desert Bandit Army",icon_khergit|carries_goods(2),0,fac_desert_bandits,bandit_personality,[(trp_desert_bandit,20,120),(trp_desert_bandit_normal,20,120),(trp_desert_bandit_hard,20,120),(trp_sarranid_camel_jezzailis,10,40)]),   

	#Forest Bandits
	("forest_bandits","Forest Thieves",icon_lav_infantry_medium|carries_goods(2),0,fac_forest_bandits,bandit_personality,[(trp_forest_bandit,10,120),(trp_forest_bandit_normal,1,10)]),
	("forest_bandits_normal","Forest Army",icon_lav_infantry_medium|carries_goods(2),0,fac_forest_bandits,bandit_personality,[(trp_forest_bandit,10,120),(trp_forest_bandit_normal,10,120),(trp_bandit_normal,5,15),(trp_brigand_normal,5,15)]), 
	("forest_bandits_hard","The Merry Men",icon_lav_infantry_medium|carries_goods(2),0,fac_forest_bandits,bandit_personality,[(trp_forest_bandit,20,120),(trp_forest_bandit_normal,20,120),(trp_forest_bandit_hard,20,120),(trp_brigand_hard,20,30),(trp_swadian_landsknecht_expert,5,10),(trp_swadian_royal_huntsman,15,25)]),  

	#Mountain Bandits
	("mountain_bandits","Mountain Men",icon_lav_horseman_medium|carries_goods(2),0,fac_mountain_bandits,bandit_personality,[(trp_mountain_bandit,10,120),(trp_mountain_bandit_normal,1,10)]),
	("mountain_bandits_normal","Mountain Rebels",icon_lav_horseman_medium|carries_goods(2),0,fac_mountain_bandits,bandit_personality,[(trp_mountain_bandit,10,120),(trp_mountain_bandit_normal,10,120),(trp_bandit_normal,5,15),(trp_brigand_normal,5,15)]), 
	("mountain_bandits_hard","Mountain Rebel Army",icon_lav_horseman_medium|carries_goods(2),0,fac_mountain_bandits,bandit_personality,[(trp_mountain_bandit,20,120),(trp_mountain_bandit_normal,20,120),(trp_mountain_bandit_hard,20,120),(trp_bandit_hard,20,30),(trp_brigand_hard,20,30),(trp_rhulg_destroyer,10,25)]),   

	#Sea Raiders
	("sea_raiders","Sea Raiders",icon_lav_infantry_heavy|carries_goods(2),0,fac_sea_raiders,bandit_personality,[(trp_sea_raider,10,120),(trp_sea_raider_normal,1,10)]),
	("sea_raiders_normal","Sea Warriors",icon_lav_infantry_heavy|carries_goods(2),0,fac_sea_raiders,bandit_personality,[(trp_sea_raider,10,120),(trp_sea_raider_normal,10,120),(trp_forest_bandit_normal,20,120)]), 
	("sea_raiders_hard","Sea Kings",icon_lav_infantry_heavy|carries_goods(2),0,fac_sea_raiders,bandit_personality,[(trp_sea_raider,20,120),(trp_sea_raider_normal,20,120),(trp_sea_raider_hard,20,120),(trp_forest_bandit_hard,20,120),(trp_nord_felhammir,10,25)]),

	#Random Skeletons
	("golem_encounter","Golems",icon_khergit|carries_goods(10),0,fac_death_knights,fanatic_personality,[(trp_death_knight_flesh_golem,60,120)]), 	
	
	("remnant_encounter","Remnant Cluster",icon_khergit|carries_goods(10),0,fac_death_knights,fanatic_personality,[(trp_death_knight_remnant,100,220)]), 
	
	("skeleton_scout","Undead Scouts",icon_khergit|carries_goods(10),0,fac_death_knights,fanatic_personality,[(trp_death_knight_skeleton_rider,20,50),(trp_death_knight_remnant,30,60)]), 	
	
	("skeleton_horde","Undead Horde",icon_khergit|carries_goods(10),0,fac_death_knights,fanatic_personality,[(trp_death_knight_skeleton_rider,20,50),(trp_death_knight_skeleton_archer,60,150),(trp_death_knight_skeleton_warrior,60,100),(trp_death_knight_remnant,60,100),(trp_death_knight_flesh_golem,10,40)]), 

	("random_bad_guys_end","Bad Guys End (Placeholder)",icon_cattle|carries_goods(10),0,fac_neutral,escorted_merchant_personality,[(trp_cattle,80,120)]), 
	#RANDOM BAD GUYS END


	#DEATH KNIGHTS OMG LOL 
	("death_knights","The Dark Horde",icon_lav_horseman_heavy|carries_goods(10),0,fac_death_knights,fanatic_mission_personality,[(trp_death_knights_lord,1,1),(trp_death_knight,20,600),(trp_death_knight_footman,1000,1200),(trp_death_knight_crossbowman,1000,1200),(trp_death_knight_flesh_golem,10,40)]),

	("death_knights_defenders","The Dark Horde",icon_lav_horseman_heavy|carries_goods(10),0,fac_death_knights,fanatic_personality,[(trp_death_knight_remnant,500,500),(trp_death_knight,100,100),(trp_death_knight_footman,200,200),(trp_death_knight_crossbowman,200,200),(trp_death_knight_flesh_golem,10,40)]), 	

	#TEMPLARS OF DEWM
	("templars","The Holy Army",icon_lav_horseman_heraldic|carries_goods(10),0,fac_templars,fanatic_mission_personality,[(trp_templars_lord,1,1),(trp_templar_paragon,20,300),(trp_templar_trooper,300,1000),(trp_templar_pikeman,300,1000),(trp_sister_of_mercy,300,1000)]),

	("templars_defenders","The Holy Army",icon_lav_horseman_heraldic|carries_goods(10),0,fac_templars,fanatic_personality,[(trp_templars_lord,1,1),(trp_templar_paragon,20,300),(trp_templar_trooper,300,1000),(trp_templar_pikeman,300,1000),(trp_sister_of_mercy,300,1000)]),   	

	#WANDERING SKELETON HORDES
	("skeleton_army","Undead Army",icon_khergit|carries_goods(10),0,fac_death_knights,fanatic_personality,[(trp_death_knight_skeleton_rider,20,100),(trp_death_knight_skeleton_archer,60,400),(trp_death_knight_skeleton_warrior,60,400),(trp_death_knight_flesh_golem,1,4)]), 

	("deserters","Deserters",icon_lav_horseman_light|carries_goods(3),0,fac_deserters,bandit_personality,[]),

	("merchant_caravan","Merchant Caravan",icon_gray_knight|carries_goods(20)|pf_auto_remove_in_town|pf_quest_party,0,fac_commoners,escorted_merchant_personality,[(trp_caravan_master,1,1),(trp_caravan_guard,5,25)]),

	#NPC SPAWN FORCES BEGIN  
	("mercenaries_one","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_mercenary_fighter_woman,3,5),(trp_caravan_guard,5,25),(trp_slave_crusher,5,15)]), 

	("mercenaries_two","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_mercenary_grenadier,3,10),(trp_caravan_guard,5,25),(trp_mercenary_horseman,5,15)]), 

	("mercenaries_three","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_mercenary_infantry_woman_sergeant,3,25),(trp_caravan_guard,5,25),(trp_mercenary_swordsman,5,15)]), 

	("female_warband","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_mercenary_infantry_woman_sergeant,3,25),(trp_mercenary_fighter_woman,5,25),(trp_nord_valkyrie_expert,5,15)]), 

	("swadian_mercs","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_swadian_landsknecht_expert,5,15),(trp_swadian_royal_huntsman,15,25)]), 

	("vaegir_mercs","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_rhulg_destroyer,10,25)]),
	("rhodok_mercs","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_rhodok_bola_elite,10,25)]),
	("nord_mercs","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_nord_felhammir,10,25)]),
	("sarranid_mercs","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_sarranid_camel_jezzailis,10,25)]),
	("khergit_mercs","Mercs",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_khergit_chu_ko_nu,5,15),(trp_khergit_rocketeer_elite,15,25)]),
	
		("aleph_defenders","Aleph Defender",icon_gray_knight,0,fac_commoners,soldier_personality,[(trp_aleph,1,1)]),
	#NPC SPAWN FORCES END  

	#QUEST PARTIES BEGIN 
	("troublesome_bandits","Troublesome Bandits",icon_axeman|carries_goods(9)|pf_quest_party,0,fac_outlaws,bandit_personality,[(trp_bandit,20,120)]),
	("bandits_awaiting_ransom","Bandits Awaiting Ransom",icon_axeman|carries_goods(9)|pf_auto_remove_in_town|pf_quest_party,0,fac_neutral,bandit_personality,[(trp_bandit,24,58),(trp_kidnapped_girl,1,1,pmf_is_prisoner)]),
	("kidnapped_girl","Kidnapped Girl",icon_woman|pf_quest_party,0,fac_neutral,merchant_personality,[(trp_kidnapped_girl,1,1)]),
	("spy_partners", "Unremarkable Travellers", icon_gray_knight|carries_goods(3)|pf_default_behavior|pf_quest_party,0,fac_neutral,merchant_personality,[(trp_spy_partner,1,1),(trp_caravan_guard,5,11)]),
	("runaway_serfs","Runaway Serfs",icon_peasant|carries_goods(8)|pf_default_behavior|pf_quest_party,0,fac_neutral,merchant_personality,[(trp_farmer,6,30), (trp_peasant_woman,3,15)]),
	("spy", "Ordinary Townsman", icon_gray_knight|carries_goods(3)|pf_default_behavior|pf_quest_party,0,fac_neutral,merchant_personality,[(trp_spy,1,1)]),
	("sacrificed_messenger", "Sacrificed Messenger", icon_gray_knight|carries_goods(3)|pf_default_behavior|pf_quest_party,0,fac_neutral,merchant_personality,[]),
	#QUEST PARTIES END 

	#NEUTRAL PARTIES BEGIN 
	("village_farmers","Village Farmers",icon_peasant|pf_civilian,0,fac_innocents,merchant_personality,[(trp_farmer,5,40),(trp_peasant_woman,3,30)]),
	("kingdom_caravan_party","Caravan",icon_mule|carries_goods(25)|pf_show_faction,0,fac_commoners,merchant_personality,[(trp_caravan_master,1,1),(trp_caravan_guard,60,120),(trp_mercenary_swordsman,60,120),(trp_mercenary_cavalry,20,60)]),
	("patrol_party","Patrol",icon_gray_knight|carries_goods(2)|pf_show_faction,0,fac_commoners,patrol_personality,[(trp_caravan_guard,30,100),(trp_mercenary_swordsman,15,100),(trp_mercenary_horseman,5,50),(trp_mercenary_matchlocks,5,50)]),
	("messenger_party","Messenger",icon_gray_knight|pf_show_faction,0,fac_commoners,merchant_personality,[]),
	("raider_party","Raiders",icon_gray_knight|carries_goods(16)|pf_quest_party,0,fac_commoners,bandit_personality,[]),
	("raider_captives","Raider Captives",0,0,fac_commoners,0,[(trp_peasant_woman,6,30,pmf_is_prisoner)]),
	("prisoner_train_party","Prisoner Train",icon_gray_knight|carries_goods(5)|pf_show_faction,0,fac_commoners,merchant_personality,[]),
	("default_prisoners","Default Prisoners",0,0,fac_commoners,0,[(trp_bandit,5,10,pmf_is_prisoner)]),
	("routed_warriors","Routed Enemies",icon_vaegir_knight,0,fac_commoners,soldier_personality,[]),
	("center_reinforcements","Reinforcements",icon_axeman|carries_goods(16),0,fac_commoners,soldier_personality,[(trp_townsman,5,30),(trp_watchman,4,20)]),
	("kingdom_hero_party","War Party",icon_flagbearer_a|pf_show_faction|pf_default_behavior,0,fac_commoners,soldier_personality,[]),

	#FACTION FORCES
	#New Reinforcement structure, depending on difficulty.
	#SWADIANS
	#Casual Gamer- weak everything, token knights
	("kingdom_of_swadians_reinforcements_a", "{!}kingdom_of_swadians_reinforcements_a", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_polearm_levy,8,12),(trp_swadian_ranged_levy,4,8)]),
	("kingdom_of_swadians_reinforcements_b", "{!}kingdom_of_swadians_reinforcements_b", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_maceman_regular,3,6),(trp_swadian_ranged_levy,8,14),(trp_swadian_polearm_levy,6,12)]),
	("kingdom_of_swadians_reinforcements_c", "{!}kingdom_of_swadians_reinforcements_c", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_swordsman_regular,6,12),(trp_swadian_maceman_regular,6,12),(trp_swadian_knight_regular,1,5),]),

	#Normal- mediocre but with stiffer backing of elites; knights start showing up in numbers  
	("kingdom_of_swadians_reinforcements_a_normal", "{!}kingdom_of_swadians_reinforcements_a_normal", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_polearm_recruit,16,24),(trp_swadian_ranged_recruit,8,16)]),
	("kingdom_of_swadians_reinforcements_b_normal", "{!}kingdom_of_swadians_reinforcements_b_normal", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_maceman_regular,6,12),(trp_swadian_ranged_recruit,16,28),(trp_swadian_polearm_recruit,12,24)]),
	("kingdom_of_swadians_reinforcements_c_normal", "{!}kingdom_of_swadians_reinforcements_c_normal", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_swordsman_regular,12,24),(trp_swadian_maceman_regular,12,24),(trp_swadian_knight_regular,10,30)]), 

	#Hard- knights are now a large presence in Swadian forces, all troops are decent.
	("kingdom_of_swadians_reinforcements_a_hard", "{!}kingdom_of_swadians_reinforcements_a_hard", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_polearm_regular,16,24),(trp_swadian_ranged_regular,8,16),(trp_swadian_ranged_expert,2,8),(trp_swadian_ranged_matchlock_expert,1,6)]),
	("kingdom_of_swadians_reinforcements_b_hard", "{!}kingdom_of_swadians_reinforcements_b_hard", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_maceman_elite,6,12),(trp_swadian_ranged_regular,16,28),(trp_swadian_polearm_elite,12,24),(trp_swadian_ranged_elite,2,8),(trp_swadian_ranged_matchlock_expert,1,6)]),
	("kingdom_of_swadians_reinforcements_c_hard", "{!}kingdom_of_swadians_reinforcements_c_hard", icon_flagbearer_a, 0, fac_commoners, 0, [(trp_swadian_grimshield,5,5),(trp_swadian_swordsman_expert,12,24),(trp_swadian_maceman_elite,12,24),(trp_swadian_knight_elite,20,45)]), 

	#VAEGIRS  
	#Casual Gamer- the Vaegirs are as weak as they're ever going to be, heh
	("kingdom_of_vaegirs_reinforcements_a", "{!}kingdom_of_vaegirs_reinforcements_a", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_pikeman_recruit,4,12),(trp_vaegir_legionnaire_recruit,8,14),(trp_vaegir_archer_recruit,4,12),]),
	("kingdom_of_vaegirs_reinforcements_b", "{!}kingdom_of_vaegirs_reinforcements_b", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_archer_recruit,8,12),(trp_vaegir_crusher_recruit,6,10),(trp_vaegir_legionnaire_regular,1,3)]),
	("kingdom_of_vaegirs_reinforcements_c", "{!}kingdom_of_vaegirs_reinforcements_c", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_horseman_recruit,6,12),(trp_vaegir_legionnaire_recruit,6,10),(trp_vaegir_crusher_recruit,6,10),]),

	#Normal- ouch, they're leveled once.  And there are more of them
	("kingdom_of_vaegirs_reinforcements_a_normal", "{!}kingdom_of_vaegirs_reinforcements_a_normal", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_pikeman_regular,8,24),(trp_vaegir_legionnaire_regular,16,28),(trp_vaegir_archer_recruit,8,24),]),
	("kingdom_of_vaegirs_reinforcements_b_normal", "{!}kingdom_of_vaegirs_reinforcements_b_normal", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_archer_regular,16,24),(trp_vaegir_crusher_regular,12,20),(trp_vaegir_legionnaire_regular,2,6)]),
	("kingdom_of_vaegirs_reinforcements_c_normal", "{!}kingdom_of_vaegirs_reinforcements_c_normal", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_praetorian,1,4),(trp_vaegir_horseman_recruit,12,24),(trp_vaegir_legionnaire_recruit,12,20),(trp_vaegir_crusher_recruit,12,20),]),

	#Hard- There's a reason why "mommy" is difficult.  This nightmare army is one of them.
	("kingdom_of_vaegirs_reinforcements_a_hard", "{!}kingdom_of_vaegirs_reinforcements_a_hard", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_praetorian,1,4),(trp_vaegir_pikeman_elite,8,24),(trp_vaegir_legionnaire_elite,16,28),(trp_vaegir_archer_elite,8,24),(trp_mercenary_cannoneer,2,8)]),
	("kingdom_of_vaegirs_reinforcements_b_hard", "{!}kingdom_of_vaegirs_reinforcements_b_hard", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_praetorian,1,4),(trp_vaegir_archer_elite,16,24),(trp_vaegir_crusher_elite,12,20),(trp_vaegir_legionnaire_elite,2,6)]),
	("kingdom_of_vaegirs_reinforcements_c_hard", "{!}kingdom_of_vaegirs_reinforcements_c_hard", icon_flagbearer_b, 0, fac_commoners, 0, [(trp_vaegir_praetorian,1,4),(trp_vaegir_horseman_elite,12,24),(trp_vaegir_legionnaire_elite,12,20),(trp_vaegir_crusher_elite,12,20)]),

	#KHERGITS  
	#Casual Gamer- not too rough.
	("kingdom_of_khergits_reinforcements_a", "{!}kingdom_of_khergits_reinforcements_a", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_cavalry_archer_recruit,4,12),(trp_khergit_infantry_archer_levy,8,14),(trp_khergit_infantry_nanigata_levy,4,12),]),
	("kingdom_of_khergits_reinforcements_b", "{!}kingdom_of_khergits_reinforcements_b", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_infantry_polearm_recruit,4,12),(trp_khergit_infantry_archer_levy,8,14),(trp_khergit_infantry_nanigata_levy,4,12),]),
	("kingdom_of_khergits_reinforcements_c", "{!}kingdom_of_khergits_reinforcements_c", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_lancer_recruit,6,12),(trp_khergit_cavalry_archer_recruit,6,12),]),

	#Normal- "gee, there sure are a lot of these guys..."  
	("kingdom_of_khergits_reinforcements_a_normal", "{!}kingdom_of_khergits_reinforcements_a_normal", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_cavalry_archer_regular,12,36),(trp_khergit_infantry_archer_recruit,24,42),(trp_khergit_infantry_nanigata_recruit,12,36),]),
	("kingdom_of_khergits_reinforcements_b_normal", "{!}kingdom_of_khergits_reinforcements_b_normal", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_infantry_polearm_regular,12,36),(trp_khergit_infantry_archer_recruit,24,42),(trp_khergit_infantry_nanigata_recruit,12,36),]),
	("kingdom_of_khergits_reinforcements_c_normal", "{!}kingdom_of_khergits_reinforcements_c_normal", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_lancer_recruit,18,24),(trp_khergit_lancer_regular,18,36),(trp_khergit_cavalry_archer_regular,24,48),]),

	#Hard- Rolling Thunder.  Ghengis would be proud, once he finished rolling over in his grave.  
	("kingdom_of_khergits_reinforcements_a_hard", "{!}kingdom_of_khergits_reinforcements_a_hard", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_infantry_polearm_regular,12,36),(trp_khergit_infantry_archer_regular,24,42),(trp_khergit_infantry_nanigata_regular,12,36),]),
	("kingdom_of_khergits_reinforcements_b_hard", "{!}kingdom_of_khergits_reinforcements_b_hard", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_infantry_polearm_elite,12,36),(trp_khergit_infantry_archer_expert,24,42),(trp_khergit_infantry_nanigata_elite,12,36),(trp_mercenary_cannoneer,2,8)]),
	("kingdom_of_khergits_reinforcements_c_hard", "{!}kingdom_of_khergits_reinforcements_c_hard", icon_khergit_horseman_b, 0, fac_commoners, 0, [(trp_khergit_lancer_regular,18,24),(trp_khergit_lancer_elite,18,36),(trp_khergit_cavalry_archer_expert,24,48),(trp_khergit_ronin,5,12)]),

	#NORDS
	#Casual- Vikings, as pansies.
	("kingdom_of_nords_reinforcements_a", "{!}kingdom_of_nords_reinforcements_a", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_axeman_levy,8,16),(trp_nord_archer_recruit,8,16),(trp_nord_spearman_recruit,1,4),]),
	("kingdom_of_nords_reinforcements_b", "{!}kingdom_of_nords_reinforcements_b", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_axeman_levy,8,16),(trp_nord_archer_recruit,8,16),(trp_nord_spearman_recruit,1,4),]),
	("kingdom_of_nords_reinforcements_c", "{!}kingdom_of_nords_reinforcements_c", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_valkyrie_regular,6,12),(trp_nord_huscarl_regular,6,12)]),

	#Normal- getting a little tricky, but they're still pretty weak.  
	("kingdom_of_nords_reinforcements_a_normal", "{!}kingdom_of_nords_reinforcements_a_normal", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_axeman_recruit,16,32),(trp_nord_archer_regular,16,32),(trp_nord_spearman_regular,16,32),]),
	("kingdom_of_nords_reinforcements_b_normal", "{!}kingdom_of_nords_reinforcements_b_normal", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_axeman_levy,16,32),(trp_nord_archer_recruit,16,32),(trp_nord_spearman_elite,16,32),(trp_nord_blunderbus,8,16)]),
	("kingdom_of_nords_reinforcements_c_normal", "{!}kingdom_of_nords_reinforcements_c_normal", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_valgarde,1,4),(trp_nord_valkyrie_elite,12,24),(trp_nord_huscarl_elite,12,24),(trp_nord_beserkir,1,5)]),

	#Hard- RAWR.  You like Beserkirs coming at you in large numbers, right?  Who doesn't?
	("kingdom_of_nords_reinforcements_a_hard", "{!}kingdom_of_nords_reinforcements_a_hard", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_valgarde,1,4),(trp_nord_beserkir,16,32),(trp_nord_archer_elite,16,32),(trp_nord_spearman_elite,16,32)]),
	("kingdom_of_nords_reinforcements_b_hard", "{!}kingdom_of_nords_reinforcements_b_hard", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_valgarde,1,2),(trp_nord_axeman_elite,16,32),(trp_nord_archer_expert,16,32),(trp_nord_spearman_expert,16,32),(trp_mercenary_cannoneer,2,8),(trp_nord_blunderbus,4,32)]),
	("kingdom_of_nords_reinforcements_c_hard", "{!}kingdom_of_nords_reinforcements_c_hard", icon_lav_infantry_heavy, 0, fac_commoners, 0, [(trp_nord_valgarde,1,4),(trp_nord_valkyrie_expert,12,24),(trp_nord_huscarl_elite,12,24),(trp_nord_beserkir,5,10)]),

	#RHODOKS
	#Casual Gamer- they're still speedbumps.
	("kingdom_of_rhodoks_reinforcements_a", "{!}kingdom_of_rhodoks_reinforcements_a",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_spearman_levy,6,14),(trp_rhodok_stormtroop_recruit,6,12)]),
	("kingdom_of_rhodoks_reinforcements_b", "{!}kingdom_of_rhodoks_reinforcements_b",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_crossbowman_recruit,8,24),(trp_rhodok_pistolero_regular,8,14)]),
	("kingdom_of_rhodoks_reinforcements_c", "{!}kingdom_of_rhodoks_reinforcements_c",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_condottieri_elite,4,8)]),

	#Normal- now with a bit more cowbell.  Note the condottieri.
	("kingdom_of_rhodoks_reinforcements_a_normal", "{!}kingdom_of_rhodoks_reinforcements_a_normal",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_spearman_recruit,12,28),(trp_rhodok_stormtroop_regular,12,24)]),
	("kingdom_of_rhodoks_reinforcements_b_normal", "{!}kingdom_of_rhodoks_reinforcements_b_normal",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_crossbowman_regular,16,48),(trp_rhodok_pistolero_regular,16,28),(trp_rhodok_crossbowman_elite,16,28)]),
	("kingdom_of_rhodoks_reinforcements_c_normal", "{!}kingdom_of_rhodoks_reinforcements_c_normal",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_condottieri_elite,16,24)]),

	#Hard- this is what it looks like, when the Rhodoks don't suck.  Hammer and anvil, baby. 
	("kingdom_of_rhodoks_reinforcements_a_hard", "{!}kingdom_of_rhodoks_reinforcements_a_hard",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_spearman_elite,12,28),(trp_rhodok_stormtroop_elite,12,24),(trp_rhodok_schiopettieri,8,30),(trp_rhodok_bola_elite,12,24)]),
	("kingdom_of_rhodoks_reinforcements_b_hard", "{!}kingdom_of_rhodoks_reinforcements_b_hard",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_crossbowman_elite,16,48),(trp_rhodok_pistolero_elite,16,28),(trp_rhodok_crossbowman_elite,16,28),(trp_mercenary_cannoneer,2,8)]),
	("kingdom_of_rhodoks_reinforcements_c_hard", "{!}kingdom_of_rhodoks_reinforcements_c_hard",icon_lav_horseman_heavy, 0, fac_commoners, 0, [(trp_rhodok_condottieri_elite,20,30),(trp_rhodok_condottieri_expert,4,8)]),

	#SARRANIDS
	#Casual Gamer- not too bad, not too great.  Kinda meh for sieges.
	("kingdom_of_sarranids_reinforcements_a", "{!}kingdom_of_sarranids_reinforcements_a",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_afrizar_regular,6,14),(trp_sarranid_irregular_levy,6,12)]),
	("kingdom_of_sarranids_reinforcements_b", "{!}kingdom_of_sarranids_reinforcements_b",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_archer_recruit,4,12),(trp_sarranid_swordsman_regular,8,14)]),
	("kingdom_of_sarranids_reinforcements_c", "{!}kingdom_of_sarranids_reinforcements_c",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_horseman_regular,6,12)]),

	#Normal.  Starting to get a bit prickly now.  Those darn Jezzailis start showing up.
	("kingdom_of_sarranids_reinforcements_a_normal", "{!}kingdom_of_sarranids_reinforcements_a_normal",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_afrizar_regular,30,45),(trp_sarranid_irregular_recruit,6,12),(trp_sarranid_irregular_regular,6,12)]),
	("kingdom_of_sarranids_reinforcements_b_normal", "{!}kingdom_of_sarranids_reinforcements_b_normal",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_archer_regular,16,32),(trp_sarranid_swordsman_regular,16,28),(trp_sarranid_irregular_regular,12,24)]),
	("kingdom_of_sarranids_reinforcements_c_normal", "{!}kingdom_of_sarranids_reinforcements_c_normal",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_horseman_regular,12,24),(trp_sarranid_horseman_elite,4,8)]),  

	#Hard.  Gee, getting run over by masses of camels sure is fun.  And how's about dealing with expert Afrizars?
	("kingdom_of_sarranids_reinforcements_a_hard", "{!}kingdom_of_sarranids_reinforcements_a_hard",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_afrizar_elite,30,45),(trp_sarranid_irregular_regular,6,12),(trp_sarranid_irregular_elite,6,12),(trp_sarranid_irregular_expert,6,18)]),
	("kingdom_of_sarranids_reinforcements_b_hard", "{!}kingdom_of_sarranids_reinforcements_b_hard",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_archer_elite,16,32),(trp_sarranid_swordsman_elite,16,28),(trp_sarranid_archer_expert,12,24),(trp_mercenary_cannoneer,2,8),(trp_sarranid_swordsman_expert,8,16),(trp_sarranid_afrizar_expert,5,10)]),
	("kingdom_of_sarranids_reinforcements_c_hard", "{!}kingdom_of_sarranids_reinforcements_c_hard",icon_lav_horseman_sarranid, 0, fac_commoners, 0, [(trp_sarranid_dervish,4,4),(trp_sarranid_irregular_elite,3,6),(trp_sarranid_irregular_expert,3,9),(trp_sarranid_horseman_elite,12,24),(trp_sarranid_horseman_expert,4,8),(trp_sarranid_cataphracts,4,8)]),   
	#END FACTION REINFORCEMENTS

	#LAIRS BEGIN
	("steppe_bandit_lair" ,"Steppe Bandit Lair",icon_bandit_lair|carries_goods(2)|pf_is_static|pf_hide_defenders,0,fac_neutral,bandit_personality,[(trp_steppe_bandit,15,120)]),
	("taiga_bandit_lair","Tundra Bandit Lair",icon_bandit_lair|carries_goods(2)|pf_is_static|pf_hide_defenders,0,fac_neutral,bandit_personality,[(trp_ruski_soldat,15,120)]),
	("desert_bandit_lair" ,"Desert Bandit Lair",icon_bandit_lair|carries_goods(2)|pf_is_static|pf_hide_defenders,0,fac_neutral,bandit_personality,[(trp_desert_bandit,15,120)]),
	("forest_bandit_lair" ,"Forest Bandit Camp",icon_bandit_lair|carries_goods(2)|pf_is_static|pf_hide_defenders,0,fac_neutral,bandit_personality,[(trp_forest_bandit,15,120)]),
	("mountain_bandit_lair" ,"Mountain Bandit Hideout",icon_bandit_lair|carries_goods(2)|pf_is_static|pf_hide_defenders,0,fac_neutral,bandit_personality,[(trp_mountain_bandit,15,120)]),
	("sea_raider_lair","Sea Raider Landing",icon_bandit_lair|carries_goods(2)|pf_is_static|pf_hide_defenders,0,fac_neutral,bandit_personality,[(trp_sea_raider,15,120)]),
	("looter_lair","Kidnappers' Hideout",icon_bandit_lair|carries_goods(2)|pf_is_static|pf_hide_defenders,0,fac_neutral,bandit_personality,[(trp_looter,15,120)]),
	("bandit_lair_templates_end","{!}bandit_lair_templates_end",icon_axeman|carries_goods(2)|pf_is_static,0,fac_outlaws,bandit_personality,[(trp_sea_raider,15,50)]),
	#LOOTERS FOR FIRST QUEST
	("leaded_looters","Band of robbers",icon_axeman|carries_goods(8)|pf_quest_party,0,fac_neutral,bandit_personality,[(trp_looter_leader,1,1),(trp_looter,15,15)]),
]
